<?php

//TODO: проверять хватает ли прав для создания файлов на сервере!


namespace UBRIR;

include_once 'WordpressUBRiRConnector.php';

include_once 'ubrr.core/_autoload.php';

include_once($_SERVER['DOCUMENT_ROOT'].'/wp-load.php');

class Wordpress extends GatewayInteractionPanel
{
    static $known_shops_plugins = Array();

    static $optionList = Array(
        'shop_id' =>
            Array(
                'GROUP' => 'UBRR_SETTINGS',
                'title' => 'Номер ретейлера',
                'type' => 'text',
                'value' => '',
            ),
        'certificate_password' =>
            Array(
                'GROUP' => 'UBRR_SETTINGS',
                'title' => 'Пароль к сертификату',
                'type' => 'text',
                'value' => '',
            ),
        'post_payment' =>
            Array(
                'GROUP' => 'UBRR_SETTINGS',
                'title' => 'Отложенный платеж',
                'type' => 'checkbox',
                'value' => '',
            ),
        'ubrr_shop_name' =>
            Array(
                'GROUP' => 'UBRR_NOTIFICATIONS_SHOP_NAME',
                'title' => 'Название магазина',
                'type' => 'text',
                'value' => '',
            ),
        'ubrr_shop_name_y' =>
            Array(
                'GROUP' => 'UBRR_NOTIFICATIONS_SHOP_NAME',
                'title' => 'Указывать название магазина (Д\Н)',
                'type' => 'checkbox',
                'value' => '',
            ),

        'ubrr_email' =>
            Array(
                'GROUP' => 'UBRR_NOTIFICATIONS_EMAIL',
                'title' => 'Email администратора магазина (для платежных уведомлений)',
                'type' => 'text',
                'value' => '',
            ),
        'ubrr_email_y' =>
            Array(
                'GROUP' => 'UBRR_NOTIFICATIONS_EMAIL',
                'title' => 'Отправлять почту (Д\Н)',
                'type' => 'checkbox',
                'value' => '',
            ),

        'ubrr_notifications_y' =>
            Array(
                'GROUP' => 'UBRR_NOTIFICATIONS',
                'title' => 'Включить уведомления по e-mail',
                'type' => 'checkbox',
                'value' => '',
            ),

        'ubrr_shop_site_y' =>
            Array(
                'GROUP' => 'UBRR_NOTIFICATIONS',
                'title' => 'Ссылка на сайт магазина',
                'type' => 'checkbox',
                'value' => '',
            ),

        'ubrr_shop_email' =>
            Array(
                'GROUP' => 'UBRR_NOTIFICATIONS',
                'title' => 'E-mail магазина',
                'type' => 'checkbox',
                'value' => '',
            ),
        'ubrr_amount_y' =>
            Array(
                'GROUP' => 'UBRR_NOTIFICATIONS',
                'title' => 'Сумма операции',
                'type' => 'checkbox',
                'value' => '',
            ),
        'ubrr_date_y' =>
            Array(
                'GROUP' => 'UBRR_NOTIFICATIONS',
                'title' => 'Дата операции',
                'type' => 'checkbox',
                'value' => '',
            ),
        'ubrr_ordernum_y' =>
            Array(
                'GROUP' => 'UBRR_NOTIFICATIONS',
                'title' => 'Номер заказа',
                'type' => 'checkbox',
                'value' => '',
            ),
        'ubrr_cardnum_y' =>
            Array(
                'GROUP' => 'UBRR_NOTIFICATIONS',
                'title' => 'Номер карты',
                'type' => 'checkbox',
                'value' => '',
            ),
        'ubrr_cardholder_y' =>
            Array(
                'GROUP' => 'UBRR_NOTIFICATIONS',
                'title' => 'Держатель карты',
                'type' => 'checkbox',
                'value' => '',
            ),
        'ubrr_opertype_y' =>
            Array(
                'GROUP' => 'UBRR_NOTIFICATIONS',
                'title' => 'Тип операции',
                'type' => 'checkbox',
                'value' => '',
            ),
        'test_mode' =>
            Array(
                'GROUP' => 'UBRR_SERVICE',
                'title' => 'Тестовый режим',
                'type' => 'checkbox',
                'value' => '',
            ),
        'bank_email' =>
            Array(
                'GROUP' => 'UBRR_SERVICE',
                'title' => 'E-mail банка',
                'type' => 'text',
                'value' => '',
            ),
    );

    function __construct($useLogs = true)
    {
        //Добавляем настройки статусов в зависимости от плагина
        self::ExtendSettings();

        $wordpressConnector = new \WordpressUBRiRConnector();
        parent::__construct($wordpressConnector, $useLogs);
    }

    static function Init()
    {
        $shopPluginConfigs = self::GetShopPluginList();

        foreach ($shopPluginConfigs as $plugin_name => $shop_plugin_config) {
            $shop_plugin_found = self::isShopPluginFound($plugin_name);

            if ($shop_plugin_found) {
                $shopPluginsListDir = self::GetShopPluginsDir();

                $initFilePath = $shopPluginsListDir.$plugin_name.'/_init.php';
                if (file_exists($initFilePath)) {
                    include_once($initFilePath);
                }
            }
        }
    }

    private static function GetShopPluginsDir()
    {
        $moduleRootDir = realpath(dirname(__FILE__).'/');
        $shopPluginsListDir = $moduleRootDir.'/wp_shop_plugins/';

        return $shopPluginsListDir;
    }

    public static function GetShopPluginList()
    {
        if (count(self::$known_shops_plugins) === 0) {
            //Load shop plugins configs

            $shopPluginsListDir = self::GetShopPluginsDir();
            $pluginDirs = scandir($shopPluginsListDir);
            foreach ($pluginDirs as $shopPluginCode) {
                if ($shopPluginCode == '.' || $shopPluginCode == '..') {
                    continue;
                }

                $configFilePath = $shopPluginsListDir.$shopPluginCode.'/_config.php';
                if (file_exists($configFilePath)) {
                    include_once $configFilePath;

                    $configVariable = strtolower(str_replace(Array('-'), Array('_'), $shopPluginCode)).'_ubrr_config';
                    global ${$configVariable};
                    $arConfig = ${$configVariable};
                    foreach ($arConfig as $key => $config) {
                        self::$known_shops_plugins[$key] = $config;
                    }
                    // $pluginConfig = array_pop($arConfig);
                }
            }
        }

        return self::$known_shops_plugins;
    }

    public static function isShopPluginActive($plugin_name)
    {
        $shopPluginsListDir = self::GetShopPluginsDir();
        if (is_dir($shopPluginsListDir.$plugin_name)) {
            global $isPluginInstalledCheckResult, $shopPluginConfig;

            $shopPluginConfigs = self::GetShopPluginList();
            $shopPluginConfig = $shopPluginConfigs[$plugin_name];

            $checkFilePath = $shopPluginsListDir.$plugin_name.'/_check_is_active.php';
            include_once $checkFilePath;

            return $isPluginInstalledCheckResult;
        }

        return false;
    }

    public static function isShopPluginFound($plugin_name)
    {
        $shopPluginConfigs = self::GetShopPluginList();
        $shopPluginConfig = $shopPluginConfigs[$plugin_name];
        $pluginInfo = self::GetWordpressPluginInfo($shopPluginConfig['Title']);

        if ($pluginInfo !== null) {
            return true;
        }

        return false;
    }

    public static function GetShopPluginData($plugin_name)
    {
    }

    public function __destruct()
    {
        parent::__destruct(); // TODO: Change the autogenerated stub
    }

    public function PluginUninstall()
    {
        $shopPluginConfigs = self::GetShopPluginList();
        foreach ($shopPluginConfigs as $plugin_name => $shop_plugin_data) {
            self::ManualDeletePaySystem($plugin_name);
        }
    }

    public function UpdateSettings()
    {
        //Обновляем настройки если форма отправлена
        if (isset($_POST['update_settings_btn'])) {
            // "Защита" от хакеров
            if (function_exists('current_user_can') && !current_user_can('manage_options')) {
                die (_e('Нет доступа', 'ubrr'));
            }
            if (function_exists('check_admin_referer')) {
                check_admin_referer('update_settings');
            }

            foreach (self::$optionList as $key => $value) {
                if ($value['GROUP'] == 'UBRR_SETTINGS') {
                    update_option($key, $_POST[$key]);
                }
            }
        }
    }

    function UpdateShopSettings()
    {
        if (isset($_POST['ubrr_update_shop_settings_btn'])) {

            //Записываем значения полей

            foreach (self::$optionList as $key => $value) {
                if (isset($_POST[$key])) {
                    update_option($key, $_POST[$key]);
                }
            }
        }
    }

    function UpdateNotificationsSettings()
    {
        //Обновляем настройки если форма отправлена
        if (isset($_POST['update_notifications_settings_btn'])) {
            // "Защита" от хакеров
            if (function_exists('current_user_can') && !current_user_can('manage_options')) {
                die (_e('Нет доступа', 'ubrr'));
            }
            if (function_exists('check_admin_referer')) {
                check_admin_referer('update_notifications_settings');
            }

            $notificationOptions = self::GetSettingsGroup('UBRR_NOTIFICATIONS');

            //Записываем значения полей
            foreach ($notificationOptions as $key => $value) {
                update_option($key, $_POST[$key]);
            }
        }
    }

    function UpdateServiceSettings()
    {
        if (isset($_POST['update_service_settings_btn'])) {

            //Записываем значения полей

            foreach (self::$optionList as $key => $value) {
                if (isset($_POST[$key])) {
                    update_option($key, $_POST[$key]);
                }
            }
            if (!isset($_POST['test_mode'])) {
                update_option('test_mode', '0');
            }
        }
    }

    static function ExtendSettings()
    {
        $shopPluginConfigs = self::GetShopPluginList();

        foreach ($shopPluginConfigs as $plugin_name => $shop_plugin_config) {
            $shopcode = $shop_plugin_config['settings_shopcode'];
            $init_key = 'ubrr_payment_setting_init_'.$shopcode;
            $approved_key = 'ubrr_payment_setting_approved_'.$shopcode;
            $declined_key = 'ubrr_payment_setting_decline_'.$shopcode;
            $canceled_key = 'ubrr_payment_setting_canceled_'.$shopcode;
            $group = 'SHOP_SETTINGS_'.strtoupper($shopcode);
            $ubrr_payment_init =
                Array(
                    'GROUP' => $group,
                    'title' => 'Статус заказа после инциирования оплаты',
                    'type' => 'select',
                    'value' => '',
                );
            $ubrr_payment_approved =
                Array(
                    'GROUP' => $group,
                    'title' => 'Статус заказа после успешной оплаты',
                    'type' => 'select',
                    'value' => '',
                );
            $ubrr_payment_declined =
                Array(
                    'GROUP' => $group,
                    'title' => 'Статус заказа после отклонения оплаты банком',
                    'type' => 'select',
                    'value' => '',
                );
            $ubrr_payment_canceled =
                Array(
                    'GROUP' => $group,
                    'title' => 'Статус заказа после отмены оплаты клиентом',
                    'type' => 'select',
                    'value' => '',
                );

            self::$optionList[$init_key] = $ubrr_payment_init;
            self::$optionList[$approved_key] = $ubrr_payment_approved;
            self::$optionList[$declined_key] = $ubrr_payment_declined;
            self::$optionList[$canceled_key] = $ubrr_payment_canceled;
        }
    }

    static function FillViewData()
    {
        global $view_data;
        $view_data = Array();

        $view_data['ubrr_wordpress_module'] = new Wordpress();

        //Разбиваем настройки на группы input'ов (UBRR_SETTINGS, UBRR_NOTIFICATIONS, etc)
        foreach (self::$optionList as $key => $inputData) {
            $group = 'INPUTS';
            if (isset($inputData['GROUP']) && !empty($inputData['GROUP'])) {
                $group = $inputData['GROUP'];
            }

            //Получаем значения полей
            $inputData['value'] = get_option($key);

            if (!is_array($view_data[$group])) {
                $view_data[$group] = Array();
            }

            $view_data[$group][$key] = $inputData;
        }
    }

    static function GetSettingsGroup($groupName = '')
    {
        $optionGroupElements = Array();

        if (!empty($groupName)) {
            foreach (self::$optionList as $key => $option) {
                if ($option['GROUP'] == $groupName) {
                    $optionGroupElements[$key] = $option;
                }
            }
        }

        return $optionGroupElements;
    }

    function ShowSettingsPage()
    {
        self::FillViewData();
        include('views/admin_settings.php');
    }

    static function ActivatePlugin()
    {
        self::AddTable();
        $wp_ubrr = new Wordpress();
        $wp_ubrr->AddPaySystem();
    }


    public function RegisterWPOptions()
    {
        foreach (self::$optionList as $key => $optionData) {
            $defaultValue = $optionData['value'];
            if ($key == 'ubrr_shop_email') {
                $defaultValue = get_option('admin_email');
            }

            add_option($key, $defaultValue);
        }
    }

    static function AddTable()
    {
        //Создаем таблицу для заказов TWPG в БД
        global $wpdb;
        $table_name = $wpdb->prefix."ubrr_twpg_orders";
        if ($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
            $sql = "CREATE TABLE ".$table_name." (
                  id INT NOT NULL AUTO_INCREMENT,
                  wp_id VARCHAR(255) NOT NULL,
                  twpg_id VARCHAR(255) NOT NULL,
                  session_id VARCHAR(255) NOT NULL,
                  ecom_session_id VARCHAR(255) NOT NULL,
                  PRIMARY KEY id (id)
                );";
            require_once(ABSPATH.'wp-admin/includes/upgrade.php');
            dbDelta($sql);
        }
    }

    static function DropTable()
    {
        global $wpdb;
        $table_name = $wpdb->prefix."ubrr_twpg_orders";
        if ($wpdb->get_var("SHOW TABLES LIKE '$table_name'") == $table_name) {
            $sql = "DROP TABLE ".$table_name.";";
            $wpdb->query($sql);
        }
    }

	static function GetPluginNameByTitle($plugin_title){
		$plugin_name = "";
		$shopPluginConfigs = self::GetShopPluginList();
		foreach($shopPluginConfigs as $shop_plugin_name => $shop_plugin_data){
			if($shop_plugin_data['Title'] === $plugin_title){
				$plugin_name = $shop_plugin_name;
				break;
			}
		}
		
		return $plugin_name;
	}
	
    function AddPaySystem()
    {
        //Получаем список всех плагинов
        $all_plugins = get_plugins();

        foreach ($all_plugins as $plugin) {
            $plugin_title = trim($plugin['Title']);
            $plugin_name = self::GetPluginNameByTitle($plugin_title);
            //Если нашли плагин в списке поддерживаем - настраиваем связь
            if (strlen($plugin_name) > 0) {
                self::ManualAddPaySystem($plugin_name);
            }
        }
    }

    static function ManualAddPaySystem($plugin_name)
    {
        $shopPluginConfigs = self::GetShopPluginList();
        if (!isset($shopPluginConfigs[$plugin_name])) {
            return false;
        }

        global $shopPluginConfig;
        $shopPluginConfig = $shopPluginConfigs[$plugin_name];

        //TODO: причесать! (перенос в _install.php

        $shopPluginsListDir = self::GetShopPluginsDir();
        $installScriptPath = $shopPluginsListDir.$plugin_name.'/_install.php';
        if (file_exists($installScriptPath)) {
            include_once $installScriptPath;
        }

        return true;
    }

    static function ManualDeletePaySystem($plugin_name)
    {
        $shopPluginConfigs = self::GetShopPluginList();
        if (!isset($shopPluginConfigs[$plugin_name])) {
            return false;
        }

        global $shopPluginConfig;
        $shopPluginConfig = $shopPluginConfigs[$plugin_name];

        $shopPluginsListDir = self::GetShopPluginsDir();
        $uninstallScriptPath = $shopPluginsListDir.$plugin_name.'/_uninstall.php';
        if (file_exists($uninstallScriptPath)) {
            include_once $uninstallScriptPath;
        }

        return true;
    }

    /**
     * При деактивации/удалении плагина убираем за собой
     */
    static function DeactivatePlugin()
    {
        self::DeletePaymentSystem();
        self::DropTable();
    }

    static function DeletePaymentSystem()
    {
        $wp_ubrr = new Wordpress();
        $wp_ubrr->PluginUninstall();
    }

    static function GetWordpressPluginInfo($plugin_title)
    {
        require_once(ABSPATH.'/wp-admin/includes/plugin.php');
        $pluginInfos = get_plugins();
        foreach ($pluginInfos as $plugin_file => $plugin_info) {
            if ($plugin_info['Title'] == $plugin_title) {
                return $plugin_info;
            }
        }

        return null;
    }
}