<?php

include_once 'ubrr.core/_autoload.php';
include_once 'WordpressUBRiRConnector.php';

use \UBRIR\GatewayForAdmin;

require_once($_SERVER['DOCUMENT_ROOT'].'/wp-load.php');
require_once('WordpressPaymentMailNotification.php');

class WordpressAdmin extends GatewayForAdmin
{
    function __construct()
    {
        $connector = new WordpressUBRiRConnector();
        parent::__construct($connector);
    }

    //Для тех окружений где недоступно однострочное создание объекта класса вроде (new WordpressAdmin())->ShowOrders() можно использовать WordpressAdmin::ShowOrders()
    static function __callStatic($functionName, $arguments)
    {
        if (static::$__callCache == null) {
            parent::_fillCallCache();
        }

        if (isset(static::$__callCache[$functionName])) {
            $className = __CLASS__;
            $GatewayForAdmin = new $className();

            return $GatewayForAdmin->$functionName($arguments);
        }

        return null;
    }

    public static function SendTestMailNotification()
    {
        $optionValues = Array();
        $adminEmail = get_option('admin_email');

        $mailNotification = new WordpressPaymentMailNotification();
        $resultData = new \UBRIR\PaymentResultViewer();

        $resultData
            ->SetPaymentTime("01/06/2017 12:00:00")
            ->SetShopOrderId('100')
            ->SetTWPG_OrderId('2000')
            ->SetCardPAN('XXXXXXXXXX8884')
            ->SetCardOwner('Test Testovich')
            ->SetPaymentAmount('2.00');

        $mailNotification->ConnectResultViewer($resultData);

        if ($mailNotification->SendPaymentNotification($adminEmail)) {
            $arResult = Array('success' => true, 'message' => 'Письмо доставлено.  Получатель: [ '.$adminEmail.' ]');
        } else {
            $arResult = Array(
                'success' => false,
                'message' => 'Не удалось отправить почтовое уведомление! Получатель: [ '.$adminEmail.' ]. Проверьте правильность email администратора магазина и возможность отправки почты с сервера',
            );
        }

        header('Content-Type: application/json');
        echo json_encode($arResult);
    }
}