<?php

/**
 * Обработка POST-запросов
 *
 */

use UBRIR\NewCertificates;

if (!empty($_POST["action"])) {
    include_once 'WordpressAdmin.php';

    $wordpressAdmin = new WordpressAdmin();

    switch ($_POST["action"]) {
        case 'delete_pay_system':
            echo UBRIR\Wordpress::ManualDeletePaySystem($_POST['plugin_name']);
            break;
        case 'add_pay_system':
            echo UBRIR\Wordpress::ManualAddPaySystem($_POST['plugin_name']);
            break;
        case 'get_plugins':
            {
                global $view_data;
                UBRIR\Wordpress::FillViewData();
                $shop_plugin_configs = UBRIR\Wordpress::GetShopPluginList();

                foreach ($shop_plugin_configs as $plugin_name => $shop_plugin_config) {
                    $shop_plugin_found = UBRIR\Wordpress::isShopPluginFound($plugin_name);

                    $shop_plugins[$plugin_name] = $shop_plugin_config;
                    $shop_plugins[$plugin_name]['shop_plugin_found'] = $shop_plugin_found;

                    if ($shop_plugin_found) {
                        $shop_plugin_active = UBRIR\Wordpress::isShopPluginActive($plugin_name);
                        $shop_plugin_data = UBRIR\Wordpress::GetWordpressPluginInfo($shop_plugin_config['Title']);

                        $shop_plugins[$plugin_name]['ubrr_payment_integrated'] = $shop_plugin_active;
                        $shop_plugins[$plugin_name]['wp_plugin_data'] = $shop_plugin_data;
                    }

                }
                $view_data['shop_plugins'] = $shop_plugins;
                include_once('views/plugins.php');
            }
            break;
        case 'get_orders':
            {
                $wordpressAdmin->ShowOrders();
            }
            break;
        case 'get_log':
            {
                $wordpressAdmin->ShowLog();
            }
            break;
        case 'delete_log':
            {
                $wordpressAdmin->ClearLog();
                echo 'Лог очищен';
            }
            break;
        case 'get_order_status':
            {
                if (!empty($_POST['twpg_id'])) {
                    $TWPG_OrderId = intval($_POST['twpg_id']);

                    $wordpressAdmin->JsonOrderStatus($TWPG_OrderId);
                }
            }
            break;
        case 'get_order_info':
            {

                if (!empty($_POST['twpg_id'])) {
                    $TWPG_OrderId = intval($_POST['twpg_id']);

                    $wordpressAdmin->HtmlInJsonOrderInfo($TWPG_OrderId);
                }
            }
            break;
        case 'get_reconcile':
            {
                $wordpressAdmin->HtmlInJsonReconcile();
            }
            break;
        case 'get_journal':
            {
                $wordpressAdmin->HtmlInJsonJournal();
            }

            break;
        case 'send_test_mail':
            {
                WordpressAdmin::SendTestMailNotification();
                break;
            }
        case 'send_request':
            {

                $connector = new WordpressUBRiRConnector();
                $panel = new \UBRIR\Wordpress();
                $panel->ConnectToCMS($connector);
                $cert = new NewCertificates($panel);

                $arCountryList = \UBRIR\TypeEnums::GetCountryList();
                $arRuRegionsList = \UBRIR\TypeEnums::GetRuRegionList();
                $arRuCityList = \UBRIR\TypeEnums::GetRuCityList();


                $country = $_REQUEST['country'];
                $region = $_REQUEST['region'];
                $city = $_REQUEST['city'];
                $organization = $_REQUEST['organization'];;
                $new_cert_pass = $_REQUEST['keyPass'];
                $connector->SetNewPrivateCertificatePassword($new_cert_pass);

                if (!empty($country)) {
                    if (isset($arCountryList[$country])) {
                        $country = $arCountryList[$country];
                    } else {
                        $country = \UBRIR\Helpers::Transliterate($country);
                    }
                }

                if (!empty($region)) {
                    if (isset($arRuRegionsList[$region])) {
                        $region = $arRuRegionsList[$region];
                    } else {
                        $region = \UBRIR\Helpers::Transliterate($region);
                    }
                }

                if (!empty($city)) {
                    $city = \UBRIR\Helpers::Transliterate($city);
                }

                if (!empty($organization)) {
                    $organization = \UBRIR\Helpers::Transliterate($organization);
                }

                $generated = $cert->Generate(
                    $_REQUEST['merchantId'],
                    $_REQUEST['emailFrom'],
                    $_REQUEST['keyPass'],
                    $country,
                    $region,
                    $city,
                    $organization
                );
                header('Content-Type: application/json');
                echo json_encode($generated->GetResultArray());

                if ($generated->isSuccess()) {
                    $ajax_response = '<h2>Запрос на выпуск сертификата успешно выполнен. Ожидайте ответа из банка на почту указанную в форме генерации запроса!</h2>';

                    return $ajax_response;
                } else {
                    $arMessages = $generated->GetMessages();
                    $ajax_response = $arMessages['ERROR'][0];

                    return $ajax_response;
                }

            }
    }
}