//Auto UBRIR_Admin.Init(); in end

(function () {
    var _data = {
        'ajaxEntryPointUrl': null,
        'DOMReady': false,
        'connectedModules': []
    };

    var UBRIR_Admin = {};
    window['UBRIR_Admin'] = UBRIR_Admin;

    UBRIR_Admin['Init'] = function () {
        document.addEventListener('DOMContentLoaded', function () {
            if (window.hasOwnProperty('ubrir_ajax_entry_point'))
                UBRIR_Admin.setAjaxEntryPointUrl(window['ubrir_ajax_entry_point']);

            UBRIR_Admin.afterDOMReady();
        });
    };

    UBRIR_Admin['afterDOMReady'] = function () {
        for (var i = 0; i < _data.connectedModules.length; i++) {
            UBRIR_Admin[_data.connectedModules[i]].Init();
        }

        _data.DOMReady = true;
    };

    UBRIR_Admin['connectUbrirSubmodule'] = function (moduleCode) {
        if (!_data.DOMReady)
            _data.connectedModules.push(moduleCode);
        else {
            UBRIR_Admin[moduleCode].Init();
        }
    };

    var Helpers = {};
    UBRIR_Admin['Helpers'] = Helpers;

    Helpers['ScrollTo'] = function (toElement, duration) {
        scrollTo(toElement.offsetTop, duration);

        function scrollTo(to, duration) {

            if (duration <= 0)
                return;

            const tickLength = 10;
            var scrolledElement = document.body;
            var difference = to - scrolledElement.scrollTop;
            var perTick = difference / duration * tickLength;

            setTimeout(function () {
                scrolledElement.scrollTop = scrolledElement.scrollTop + perTick;
                scrollTo(to, duration - tickLength);
            }, tickLength);
        }
    };

    var Ajax = {};

    // Универсальная функция для создания нового объекта XMLHttpRequest
    Ajax['getXhrObject'] = function () {
        if (typeof XMLHttpRequest === 'undefined') {
            XMLHttpRequest = function () {
                try {
                    return new window.ActiveXObject("Microsoft.XMLHTTP");
                } catch (e) {
                }
            };
        }
        return new XMLHttpRequest();
    };

    Ajax['SendPOST'] = function (url, paramPairs, callbackFunc) {
        // получаем новый XMLHttpRequest-объект
        var xhr = Ajax.getXhrObject();

        if (xhr) {
            var params = [];

            for (var name in paramPairs) {
                if (paramPairs.hasOwnProperty(name)) {
                    var value = paramPairs[name];
                    params.push(name + '=' + value);
                }
            }
            // Для GET-запроса
            //url += '?' + params.join('&');

            xhr.open('POST', url, true); // открываем соединение
            // заголовки - для POST-запроса
            xhr.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');

            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4 && xhr.status === 200) { // проверяем стадию обработки и статус ответа сервера

                    var responseData = xhr.responseText;

                    if (xhr.getResponseHeader('Content-Type') == "application/json") {
                        responseData = JSON.parse(responseData);
                    }

                    if (typeof(callbackFunc) === 'function') {
                        callbackFunc(responseData);
                    }
                }
            };
            // стартуем ajax-запрос
            xhr.send(params.join('&')); // для GET запроса - xhr.send(null);
        }
    };

    UBRIR_Admin['setAjaxEntryPointUrl'] = function (url) {
        _data.ajaxEntryPointUrl = url;
    };

    UBRIR_Admin['Ajax'] = function (request_type, ajax_data, callback, error_callback) {
        var aData = {};
        if (typeof(ajax_data) === 'object') {
            aData = ajax_data;
        }
        aData['action'] = request_type;

        if (_data.ajaxEntryPointUrl === null || typeof(_data.ajaxEntryPointUrl) !== 'string') {
            console.error('Для корректной работы необходимо использовать UBRIR_Admin.setAjaxEntryPointUrl()');
            return false;
        }

        Ajax.SendPOST(_data.ajaxEntryPointUrl, aData, function (r) {
            if (typeof (callback) === 'function') {
                callback(r);
            }

            if (typeof(error_callback) === 'function' && false) //Нужно проверять возвращаемые данные
            {

            }
        });
        //TODO: error_callback
    };
})();

UBRIR_Admin.Init();