<?php
global $view_data;

$base_dir = __DIR__ . '/';
$ubrr_wordpress_module = $view_data['ubrr_wordpress_module'];
$connector = new WordpressUBRiRConnector();
$shop_id = $connector->GetShopId();
$cert_creation_date = $connector->GetCertificateCreateDate();
$current_date = date('d.m.Y', time());
$time_diff = $current_date - $cert_creation_date;
$pemExist = file_exists(realpath($base_dir . '../') . '/ubrr.core/certs/user.pem');
$adminEmail = get_option('admin_email');
include_once(realpath($base_dir . '../WordpressAdmin.php'));

//include_once (realpath($base_dir.'../ubrr.core/classes/UBRIR_TypeEnums.php'));

$typeEnums = new \UBRIR\TypeEnums();
$arCountryList = $typeEnums::GetCountryList();
$arRuRegionsList = $typeEnums::GetRuRegionList();
$arRuCityList = $typeEnums::GetRuCityList();
?>
<link rel="stylesheet" href="/wp-content/plugins/ubrr/ubrr.core/views/css/ubrir.css" type="text/css" media="all">
<link rel="stylesheet" href="/wp-content/plugins/ubrr/views/css/style.css" type="text/css" media="all">
<script type="text/javascript" src="/wp-content/plugins/ubrr/views/js/jquery3.1.1.min.js"></script>
<script type="text/javascript" src="/wp-content/plugins/ubrr/views/js/jquery-ui.min.js"></script>
<script type="text/javascript" src="/wp-content/plugins/ubrr/views/js/ubrr.admin.js"></script>


<div class="wrap">
    <h1>Интеграция с УБРиР</h1>
    <div id="tabs" class="welcome-panel">
        <ul>
            <li><a href="#tab1">Основные настройки</a></li>
            <li><a class="tab getOrders" href="#tab2">Просмотр заказов</a></li>
            <li><a class="tab getReconcile" href="#tab3">Сверка итогов</a></li>
            <li><a class="tab getJournal" href="#tab4">Журнал операций</a></li>
            <li><a href="#tab5">Выпуск сертификата</a></li>
            <li><a href="#tab6">Загрузить сертификат</a></li>
            <li><a href="#tab7">Настройки уведомлений</a></li>
            <li><a class="tab getPlugins" href="#tab8">Плагины</a></li>
            <li><a class="tab getLog" href="#tab9">Лог</a></li>
            <li><a class="tab" href="#tab10">Служебные свойства</a></li>
        </ul>

        <div id="tab1">
            <form name="update_settings" method="POST"
                  action="<?php echo $_SERVER['PHP_SELF'] ?>?page=ubrr&updated=true">
                <?php
                // "Защита" от хакеров
                if (function_exists('wp_nonce_field')) {
                    wp_nonce_field('update_settings');
                }
                ?>
                <table>
                    <?php foreach ($view_data['UBRR_SETTINGS'] as $inputName => $inputData) {
                        if
                        ($inputData['type'] == 'select'
                        ) {
                            echo '<tr><td>' . $inputData['title'] . '</td><td><select name="' . $inputName . '">';
                            foreach ($inputData['options'] as $key => $value) {
                                if ($key == $inputData['value']) {
                                    echo '<option value="' . $key . '" selected="selected">' . $value . '</option>';
                                } else {
                                    echo '<option value="' . $key . '">' . $value . '</option>';
                                }
                            }
                            echo '</select></td></tr>';
                        } else {
                            echo '<tr><td>' . $inputData['title'] . '</td>
                                <td>
                                <input title="' . $inputData['title'] . '"
                                       type="' . $inputData['type'] . '"
                                       name="' . $inputName . '"';
                            if ($inputData['type'] == 'checkbox') {
                                echo ' value="1"';
                                echo $inputData['value'] == 1 ? ' checked="checked"' : '';
                            } else {
                                echo ' value="' . $inputData['value'] . '"';
                            }
                            echo ' /></td></tr>';
                        }

                    } ?>

                    <tr>
                        <td>&nbsp;</td>
                        <td><input class="button button-primary" type="submit" name="update_settings_btn"
                                   value="Сохранить"></td>
                    </tr>
                </table>
            </form>
        </div>
        <div id="tab2">
            <div id="orderListPlace">Загружается...</div>
        </div>
        <div id="tab3">
            <div id="reconcileAjaxPlace" style="display: none;">Загружается...<br>
                <p><b>К сведению:&nbsp;</b>Сверка итогов производится на основании текущих заказов.<br/>
                    Выполнение сверки итогов переносит текущие заказы в журнал, поэтому повторный вызов сверки итогов
                    будет
                    с нулевыми значениями.</p></div>
        </div>
        <div id="tab4">
            <div id="journalAjaxPlace">Загружается...</div>
        </div>
        <div id="tab5">
            <div id="cert">
                <div id="certExpired">

                    <?php
                    //Уведомляем
                    if ($time_diff > 335) {
                        echo 'До окончания срока действия сертификата осталось: ';
                        echo 365 - $time_diff . ' дней';
                    } ?>
                </div>
                <div id="certStatus"></div>
                <span class="tabHeader">Отправить запрос на выдачу</span>
                <form id='getCertRequest' name="getCertRequest" method="POST">
                    <table>
                        <tr>
                            <td><label for="emailFrom">Ваш e-mail</label></td>
                            <td><input type="email" name="emailFrom" value="<?php echo $adminEmail ?>"
                                       required="required"><span class="required">*</span></td>
                        </tr>

                        <tr>

                            <td><label for="country">Страна</label></td>
                            <td>
                                <input type="text" name="country" placeholder="Страна, например Россия"
                                       required="required"
                                       list="dl-ru-country-list"><span class="required">*</span>
                                <datalist id="dl-ru-country-list">
                                    <?php foreach ($arCountryList as $country => $countryCode): ?>
                                        <option value="<?php echo $country ?>"><?php echo $countryCode ?></option>
                                    <?php endforeach ?>
                                </datalist>
                            </td>

                        </tr>
                        <tr>

                            <td><label for="region">Регион</label></td>
                            <td>
                                <input type="text" name="region" required="required"
                                       list="dl-ru-region-list"
                                       placeholder="Регион, например Свердловская область"><span
                                        class="required">*</span>
                                <datalist id="dl-ru-region-list">
                                    <?php foreach ($arRuRegionsList as $regionTitle => $regionCode): ?>
                                        <option value="<?php echo $regionTitle ?>"><?php echo $regionCode ?></option>
                                    <?php endforeach ?>
                                </datalist>
                            </td>

                        </tr>
                        <tr>

                            <td><label for="city">Город</label></td>
                            <td>
                                <input type="text" name="city" required="required"
                                       placeholder="Город, например Екатеринбург"
                                       list="dl-ru-city-list"><span class="required">*</span>
                                <datalist id="dl-ru-city-list">
                                    <?php foreach ($arRuCityList as $cityTitle): ?>
                                        <option><?php echo $cityTitle ?></option>
                                    <?php endforeach ?>
                                </datalist>
                            </td>

                        </tr>
                        <tr>

                            <td><label for="organization">Название организации</label></td>
                            <td>
                                <input type="text" name="organization" required="required"
                                       placeholder="Название организации, например ООО 'Компания'"><span
                                        class="required">*</span></td>

                        </tr>

                        <tr>

                            <td><label for="merchantId">Номер ретейлера</label></td>
                            <td>
                                <input type="text" name="merchantId" value="<?php if ($shop_id) {
                                    echo $shop_id;
                                } ?>"><span class="required">*</span></td>
                        </tr>
                        <tr>
                            <td><label for="keyPass">Пароль к сертификату</label></td>
                            <td><input required="required" type="text" name="keyPass"><span
                                        class="required">*</span></td>
                        </tr>
                        <tr>
                            <td><input class="button button-primary" type="submit" name="get_cert_request_btn"
                                       value="Отправить"></td>
                        </tr>
                    </table>


                </form>


            </div>
        </div>
        <div id="tab6">
            <div id="certStatus"></div>

            <div id="requestSuccess">Если вы получили от банка письмо содержащее файл [user.pem] загрузите его через
                форму ниже
            </div>
            <span>Максимальный размер файла - 5 Кб</span>

            <form enctype="multipart/form-data" id="uploadCert" name="uploadCert" method="POST"
                  action="/wp-content/plugins/ubrr/WordpressUploadFile.php">
                <table>
                    <tr>
                        <td>
                            <input type="hidden" name="MAX_FILE_SIZE" value="5000">
                            <input type="file" name="new_public_certificate">
                        </td>
                    </tr>
                    <tr>
                        <td><input class="button button-primary" type="submit" name="upload_cert"
                                   value="Отправить"></td>
                    </tr>
                </table>
            </form>

            <div id="uploadStatus"></div>
            <div class="tabHeader" id="certCreatedDate">Дата создания
                сертификата:<?php echo $cert_creation_date ?></div>
        </div>
        <div id="tab7">
            <form name="update_notifications_settings" method="POST"
                  action="<?php echo $_SERVER['PHP_SELF'] ?>?page=ubrr&updated=true">
                <?php
                // "Защита" от хакеров
                if (function_exists('wp_nonce_field')) {
                    wp_nonce_field('update_notifications_settings');
                }
                ?>
                <table>
                    <?php foreach ($view_data['UBRR_NOTIFICATIONS'] as $inputName => $inputData): ?>
                        <tr>
                            <td><?php echo $inputData['title'] ?></td>
                            <td>
                                <input title="<?php echo $inputData['title'] ?>"
                                       type="<?php echo $inputData['type'] ?>"
                                       name="<?php echo $inputName ?>"
                                       value="<?php echo ($inputData['type'] == 'checkbox') ? '1' : $inputData['value'] ?>"
                                    <?php echo ($inputData['type'] == 'checkbox' && $inputData['value'] == 1) ? 'checked="checked"' : '' ?>
                                />
                            </td>
                        </tr>
                    <?php endforeach ?>
                    <tr>
                        <td><input class="button button-primary" type="submit" name="update_notifications_settings_btn"
                                   value="Сохранить"></td>
                    </tr>
                </table>
            </form>
            <a href="#send_notification" class="button button-primary sendTestNotification">Отправить тестовое
                письмо</a>
        </div>
        <div id="tab8">
            <div id="pluginList">Поиск плагинов...</div>
        </div>
        <div id="tab9">
            <div id="log" class="logTab"> Загрузка лога...</div>
            <div class="debugBlock">
                <? if (!function_exists('curl_version')): ?>
                    <div class="error">PHP модуль CURL не установлен - без него фунционирование модуля не возможно</div>
                <? else: ?>
                    <pre><?php print_r(curl_version()) ?></pre>
                <? endif ?>
            </div>
        </div>
        <div id="tab10">
            <div id="service">
                <form id='service_settings' name="serviceSettings" method="POST">
                    <table>
                        <?php foreach ($view_data['UBRR_SERVICE'] as $inputName => $inputData): ?>
                            <tr>
                                <td><?php echo $inputData['title'] ?></td>
                                <td>
                                    <input title="<?php echo $inputData['title'] ?>"
                                           type="<?php echo $inputData['type'] ?>"
                                           name="<?php echo $inputName ?>"
                                           value="<?php echo ($inputData['type'] == 'checkbox') ? '1' : $inputData['value'] ?>"
                                        <?php echo ($inputData['type'] == 'checkbox' && $inputData['value'] == 1) ? 'checked="checked"' : '' ?>
                                    />
                                </td>
                            </tr>
                        <?php endforeach ?>
                        <tr>
                            <td><input class="button button-primary" type="submit" name="update_service_settings_btn"
                                       value="Сохранить"></td>
                        </tr>
                    </table>
                </form>

            </div>
        </div>


    </div>
