$(document).ready(function () {
    Admin_UBRR.Init();
});

(function () {
    var Admin_UBRR = {};
    window['Admin_UBRR'] = Admin_UBRR;

    var MailNotifications = {};
    Admin_UBRR['MailNotifications'] = MailNotifications;

    var OrderList = {};
    Admin_UBRR['OrderList'] = OrderList;

    var Reconcile = {};
    Admin_UBRR['Reconcile'] = Reconcile;

    var Journal = {};
    Admin_UBRR['Journal'] = Journal;

    var ShopPlugins = {};
    Admin_UBRR['ShopPlugins'] = ShopPlugins;

    var Log = {};
    Admin_UBRR['Log'] = Log;

    var Cert = {};
    Admin_UBRR['Cert'] = Cert;

    var FileUploader = {};
    Admin_UBRR['FileUploader'] = FileUploader;

    var d = {};

    Admin_UBRR['Ajax'] = function (request_type, ajax_data, callback, error_callback) {
        var jData = {};
        if (typeof(ajax_data) === 'object') {
            jData = ajax_data;
        }
        jData['action'] = request_type;

        jQuery.ajax({
            url: '/wp-content/plugins/ubrr/ajax.php',
            type: 'POST',
            data: jData,
            success: function (r) {
                if (typeof (callback) === 'function') {
                    callback(r);
                }
            },
            error: function (r) {
                if (typeof(error_callback) === 'function') {
                    error_callback(r);
                }
            }
        })
    };

    Admin_UBRR['Init'] = function () {
        loadStyleSheet('/wp-content/plugins/ubrr/views/css/jquery-ui.min.css');
        loadStyleSheet('/wp-content/plugins/ubrr/ubrr.core/views/css/ubrir.css');

        MailNotifications.Init();

        OrderList.Init();
        Reconcile.Init();
        Journal.Init();
        ShopPlugins.Init();
        Log.Init();
        Cert.Init();
        FileUploader.Init();

        $("#tabs").tabs({active: 0});
    };

    MailNotifications['Init'] = function () {
        $('.sendTestNotification').click(MailNotifications.SendTestClick);
    };

    MailNotifications['SendTestClick'] = function () {
        Admin_UBRR.Ajax('send_test_mail', {}, function (r) {
            alert(r.message);
            console.log(r);
        })
    };

    Reconcile['Init'] = function () {
        d['reconcileAjaxPlace'] = $('#reconcileAjaxPlace');

        $('.tab.getReconcile').click(Reconcile.TabClick);
    };

    Reconcile['TabClick'] = function () {
        d.reconcileAjaxPlace.show();

        Admin_UBRR.Ajax('get_reconcile', {}, Reconcile.AjaxSuccess);
    };

    Reconcile['AjaxSuccess'] = function (response) {
        if (response.hasOwnProperty('html')) {
            d.reconcileAjaxPlace.html(response['html']);
        }
    };

    Journal['Init'] = function () {
        d['journalAjaxPlace'] = $('#journalAjaxPlace');

        $('.tab.getJournal').click(Journal.TabClick);
    };

    Journal['TabClick'] = function () {
        d.journalAjaxPlace.show();

        Admin_UBRR.Ajax('get_journal', false, Journal.AjaxSuccess, Journal.AjaxError);
    };

    Journal['AjaxSuccess'] = function (response) {
        if (response.hasOwnProperty('html')) {
            Journal.Fill(response['html']);
        }
    };

    Journal['AjaxError'] = function () {
        Journal.Fill('Ошибка связи с сервером');
    };

    Journal['Fill'] = function (html) {
        d.journalAjaxPlace.html(html);
    };

    OrderList['Init'] = function () {
        d['orderListPlace'] = $('#orderListPlace');
        d['orderDetailsPlace'] = null; //На момент инициализации админки - этого элемента еще нет

        $(".tab.getOrders").click(OrderList.TabClick);
    };

    OrderList['TabClick'] = function () {
        Admin_UBRR.Ajax('get_orders', false, OrderList.AjaxSuccess);
    };

    OrderList['AjaxSuccess'] = function (response) {
        d['orderListPlace'].html(response);

        OrderList.ActivatePage();
    };

    OrderList['ShowOrderResponse'] = function (order_details_html) {
        d.orderDetailsPlace.html(order_details_html);
        var messageBlockTop = d.orderDetailsPlace.offset().top;

        //ScrollTo
        $('html,body').animate({scrollTop: messageBlockTop}, 500);
    };

    OrderList['ActivatePage'] = function () {
        d.orderDetailsPlace = $('#orderDetailsPlace');

        $(".getOrderStatus").click(OrderList.GetStatusClick);

        $(".getOrderInfo").click(OrderList.GetInfoClick);
    };

    OrderList['GetStatusClick'] = function (e) {
        e.preventDefault();
        var twpg_id = parseInt($(this).attr('data-twpg_id'));
        var $button = $(this);
        var $parentTD = $button.parent('td');

        $button.remove(); //Удаляем чтобы второй раз не нажали
        Admin_UBRR.Ajax('get_order_status', {'twpg_id': twpg_id}, function (response) {
                OrderList.GetOrderStatus_Success(response, $parentTD);
            }
        );
    };

    OrderList['GetOrderStatus_Success'] = function (response, $parentTD) {
        if (response.hasOwnProperty('success') && parseInt(response['success']) === 1) {
            $parentTD.append($('<span>' + response['label'] + '</span>'));
        }
        else {
            $parentTD.append($('<span class="error">' + response['label'] + '</span>'));
            if (response.hasOwnProperty('html')) {
                OrderList.ShowOrderResponse(response.html);
            }
        }


    };

    OrderList['GetInfoClick'] = function (e) {
        e.preventDefault();
        var $button = $(this);
        var twpg_id = parseInt($(this).attr('data-twpg_id'));

        Admin_UBRR.Ajax('get_order_info', {'twpg_id': twpg_id}, function (response) {
            OrderList.GetOrderInfo_Success(response, $button);
        });
    };

    OrderList['GetOrderInfo_Success'] = function (response, $button) {
        var $parentTD = $button.parent('td');

        if (!response.hasOwnProperty('success') || parseInt(response['success']) !== 1) {
            $parentTD.append($('<span class="error">' + response['label'] + '</span>'));
            $button.remove();
        }

        if (response.hasOwnProperty('html'))
            OrderList.ShowOrderResponse(response['html']);
    };

    ShopPlugins['Init'] = function () {
        d['shopPluginList'] = $('#pluginList');

        $(".tab.getPlugins").click(ShopPlugins.GetPluginsTabClick);
    };

    ShopPlugins['GetPluginsTabClick'] = function () {
        Admin_UBRR.Ajax('get_plugins', false, ShopPlugins.FillTab);
    };

    ShopPlugins['FillTab'] = function (r) {
        d.shopPluginList.html(r);

        $('.deletePaySystem').click(ShopPlugins.DeletePaySystemClick);

        $('.installPaySystem').click(ShopPlugins.InstallPaySystemClick);
    };

    ShopPlugins['DeletePaySystemClick'] = function () {
        var plugin_name = $(this).attr('data-plugin-name');
        Admin_UBRR.Ajax('delete_pay_system', {'plugin_name': plugin_name}, function () {
            Admin_UBRR.Ajax('get_plugins', {}, ShopPlugins.FillTab);
        });
    };

    ShopPlugins['InstallPaySystemClick'] = function () {
        var plugin_name = $(this).attr('data-plugin-name');
        Admin_UBRR.Ajax('add_pay_system', {'plugin_name': plugin_name}, function () {
            Admin_UBRR.Ajax('get_plugins', {}, ShopPlugins.FillTab);
        });
    };

    Log['Init'] = function () {
        d['logPlace'] = $('#log');

        $(".tab.getLog").click(Log.GetClick);
    };

    Log['GetClick'] = function () {
        Admin_UBRR.Ajax('get_log', false, Log.Fill);
    };

    Log['Fill'] = function (r) {
        d.logPlace.html(r);

        $('.deleteLog').click(Log.CleanClick);
    };

    Log['CleanClick'] = function () {
        Admin_UBRR.Ajax('delete_log', false, Log.Fill);
    };

    Cert['Init'] = function () {
        $('form#getCertRequest').on('submit', function (event) {
            event.preventDefault();

            var emailFrom = $('input[name=emailFrom]').val();
            var country = $('input[name=country]').val();
            var region = $('input[name=region]').val();
            var city = $('input[name=city]').val();
            var organization = $('input[name=organization]').val();
            var merchantId = $('input[name=merchantId]').val();
            var keyPass = $('input[name=keyPass]').val();
            var data = {
                'emailFrom':emailFrom,
                'country': country,
                'region': region,
                'city': city,
                'organization': organization,
                'merchantId': merchantId,
                'keyPass':keyPass
            };
            Admin_UBRR.Ajax('send_request', data, function (response) {
                var statusPlace = jQuery('#certStatus');
                var createdPlace = jQuery('#certCreatedDate');
                Cert.GetCertStatus_Success(response, statusPlace, createdPlace);
            })
        })
    };
    Cert['GetCertStatus_Success'] = function (response, statusPlace, createdPlace) {
        if (!response.hasOwnProperty('success') || parseInt(response['success']) !== 1) {
            statusPlace.html($('<span class="error">' + response['html'] + '</span>'));
        }
        else {
            statusPlace.html($('<span class="success">' + response['html'] + '</span>'));
            setTimeout(function() {window.location.reload();}, 1000);
        }

        if (response.hasOwnProperty('html'))
            OrderList.ShowOrderResponse(response['html']);
    };
    FileUploader['Init'] = function () {
        $('form#uploadCert').on('submit', function (event) {
            event.preventDefault();
            var form = $(this).get(0);

            var formData = new FormData(form);

            var xhr = new XMLHttpRequest();
            xhr.open("POST", form.getAttribute('action'));

            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        data = xhr.responseText;
                        $('#uploadStatus').html(data);
                        if(data == 'Файл успешно загружен.'){
                            setTimeout(function() {window.location.reload();}, 2000);
                        }
                    }
                }
            };

            xhr.send(formData);
        });
    }

})();

function loadStyleSheet(path, fn, scope) {
    var head = document.getElementsByTagName('head')[0], // reference to document.head for appending/ removing link nodes
        link = document.createElement('link');           // create the link node
    link.setAttribute('href', path);
    link.setAttribute('rel', 'stylesheet');
    link.setAttribute('type', 'text/css');

    var sheet, cssRules;
// get the correct properties to check for depending on the browser
    if ('sheet' in link) {
        sheet = 'sheet';
        cssRules = 'cssRules';
    } else {
        sheet = 'styleSheet';
        cssRules = 'rules';
    }

    var interval_id = setInterval(function () {                     // start checking whether the style sheet has successfully loaded
            try {
                if (link[sheet] && link[sheet][cssRules].length) { // SUCCESS! our style sheet has loaded
                    clearInterval(interval_id);                      // clear the counters
                    clearTimeout(timeout_id);

                    if (typeof(fn) === 'function')
                        fn.call(scope || window, true, link);           // fire the callback with success == true
                }
            } catch (e) {
            } finally {
            }
        }, 10), // how often to check if the stylesheet is loaded
        timeout_id = setTimeout(function () {       // start counting down till fail
            clearInterval(interval_id);             // clear the counters
            clearTimeout(timeout_id);
            head.removeChild(link);                // since the style sheet didn't load, remove the link node from the DOM
            if (typeof(fn) === 'function')
                fn.call(scope || window, false, link);// fire the callback with success == false
        }, 15000);                                 // how long to wait before failing

    head.appendChild(link);  // insert the link node into the DOM and start loading the style sheet

    return link; // return the link node;
}