$(document).ready(function () {
    loadStyleSheet('/wp-content/plugins/ubrr/views/css/ubrr.css');
    loadStyleSheet('/wp-content/plugins/ubrr/views/css/jquery-ui.min.css');
    $("#tabs").tabs({
        active: 0
    });
    $messageBlock = $('#messageBlock');

    function ActivateOrderListPage() {
        $(".getOrderStatus").click(function () {
            event.preventDefault();
            var twpg_id = parseInt($(this).attr('data-twpg_id'));
            var $button = $(this);

            jQuery.ajax({
                url: '/wp-content/plugins/ubrr/ajax.php',
                type: 'POST',
                dataType: 'json',
                data: {
                    action: "get_order_status",
                    twpg_id: twpg_id
                },
                success: function (response) {

                    if (response.hasOwnProperty('success') && parseInt(response['success']) == 1) {
                        $button.parent('td').append($('<span>' + response['order_status']['label'] + '</span>'));
                    }
                    else {
                        $button.parent('td').append($('<span class="error">' + response['order_status']['label'] + '</span>'));
                    }
                    $button.remove();

                    if (response.hasOwnProperty('html')) {
                        ShowMessage(decodeHtml(response.html), false);
                    }
                }
            });
        });

        $(".getOrderInfo").click(function () {
            event.preventDefault();
            var $button = $(this);
            var twpg_id = parseInt($(this).attr('data-twpg_id'));

            jQuery.ajax({
                url: '/wp-content/plugins/ubrr/ajax.php',
                type: 'POST',
                dataType: 'json',
                data: {
                    action: "get_order_info",
                    twpg_id: twpg_id
                },
                success: function (response) {
                    if (response.hasOwnProperty('success') && parseInt(response['success']) == 1) {
                        if (response.hasOwnProperty('html'))
                            ShowMessage((response['html']));
                    }
                    else {
                        $button.parent('td').append($('<span class="error">' + response['html'] + '</span>'));
                        $button.remove();
                    }

                }
            });
        });
    }

    function wpAjax(request_type, ajax_data, callback) {
        jQuery.ajax({
            url: '/wp-content/plugins/ubrr/ajax.php',
            type: 'POST',
            data: {
                action: request_type,
                additional: ajax_data
            },
            success: function (r) {
                if (typeof (callback) == 'function') {
                    callback(r);
                }
            }
        })
    }

    function fillPluginsList(r) {
        $('#pluginList').html(r);
        $('.deletePaySystem').click(function () {
            var plugin_name = $(this).attr('data-plugin-name');
            wpAjax('delete_pay_system', {'plugin_name': plugin_name}, function () {
                wpAjax('get_plugins', {}, fillPluginsList);
            });
        });

        $('.installPaySystem').click(function () {
            var plugin_name = $(this).attr('data-plugin-name');
            wpAjax('add_pay_system', {'plugin_name': plugin_name}, function () {
                wpAjax('get_plugins', {}, fillPluginsList);
            });
        });
    }

    $(".getPlugins").click(function () {
        wpAjax('get_plugins', {}, fillPluginsList);
    });

    $(".getOrders").click(function () {
        wpAjax('get_orders', {},
            function (r) {
                $messageBlock.html(r);

                ActivateOrderListPage();
            });
    });

    function fillLog(r) {
        $('#log').html(r);
        $('.deleteLog').click(function () {
            wpAjax('delete_log', {}, fillLog)
        })
    }

    $(".getLog").click(function () {
        wpAjax('get_log', {}, fillLog);
    });


    $('.getReconcile').click(function () {
        var $reconcileAjaxPlace = $('#reconcileAjaxPlace');
        $reconcileAjaxPlace.show();

        jQuery.ajax({
            url: '/wp-content/plugins/ubrr/ajax.php',
            type: 'POST',
            dataType: 'json',
            data: {
                action: "get_reconcile",
            },
            success: function (response) {
                if (response.hasOwnProperty('html')) {
                    $reconcileAjaxPlace.html(response['html']);
                }
                console.log(response);
            }
        });
    });

    $('.getJournal').click(function () {
        var $reconcileAjaxPlace = $('#reconcileAjaxPlace');
        $reconcileAjaxPlace.show();

        jQuery.ajax({
            url: '/wp-content/plugins/ubrr/views/ajax.php',
            type: 'POST',
            dataType: 'json',
            data: {
                action: "get_journal",
            },
            success: function (response) {
                if (response.hasOwnProperty('html')) {
                    $('#journalAjaxPlace').html(response['html']);
                }
                console.log(response);
            },
            error: function (response) {
                $('#journalAjaxPlace').html('Ошибка связи с сервером');
            }
        });
    });

    function ClearMessageBlock() {
        $messageBlock.html('');
    }

    function ShowMessage(messageHTML) {
        $messageBlock.html(messageHTML);
        var messageBlockTop = $messageBlock.offset().top;
        $('html,body').animate({scrollTop: messageBlockTop}, 500);
    }


    function loadStyleSheet(path, fn, scope) {
        var head = document.getElementsByTagName('head')[0], // reference to document.head for appending/ removing link nodes
            link = document.createElement('link');           // create the link node
        link.setAttribute('href', path);
        link.setAttribute('rel', 'stylesheet');
        link.setAttribute('type', 'text/css');

        var sheet, cssRules;
// get the correct properties to check for depending on the browser
        if ('sheet' in link) {
            sheet = 'sheet';
            cssRules = 'cssRules';
        } else {
            sheet = 'styleSheet';
            cssRules = 'rules';
        }

        var interval_id = setInterval(function () {                     // start checking whether the style sheet has successfully loaded
                try {
                    if (link[sheet] && link[sheet][cssRules].length) { // SUCCESS! our style sheet has loaded
                        clearInterval(interval_id);                      // clear the counters
                        clearTimeout(timeout_id);

                        if (typeof(fn) == 'function')
                            fn.call(scope || window, true, link);           // fire the callback with success == true
                    }
                } catch (e) {
                } finally {
                }
            }, 10), // how often to check if the stylesheet is loaded
            timeout_id = setTimeout(function () {       // start counting down till fail
                clearInterval(interval_id);             // clear the counters
                clearTimeout(timeout_id);
                head.removeChild(link);                // since the style sheet didn't load, remove the link node from the DOM
                if (typeof(fn) == 'function')
                    fn.call(scope || window, false, link);// fire the callback with success == false
            }, 15000);                                 // how long to wait before failing

        head.appendChild(link);  // insert the link node into the DOM and start loading the style sheet

        return link; // return the link node;
    }
});
