<?php

include_once '../../WordpressPaymentMailNotification.php';
include_once '../../WordpressUBRiRConnector.php';
include_once '../../../wp-e-commerce/wpsc-includes/cart.class.php';
include_once 'ecom_ubrr_merchant.php';

class eCommerceUBRIRCallback extends \UBRIR\CMS_PaymentCallback
{
    public function BeforeSendMailNotification(\UBRIR\PaymentResultViewer $resultViewer)
    {
        global $wpsc_customer_checkout_details;

        $email = $wpsc_customer_checkout_details[9]; //Молимся чтобы ничего не поменялось. Никита лучше места не нашел ;)

        $this->SetMailReceivers($email);

        return $resultViewer;
    }

    public function OnPaymentApproved($shopOrderId, $sessionId)
    {


        $payment_module = new wpsc_merchant_ubrr($shopOrderId);
        $payment_module->set_purchase_processed_by_purchid(get_option('ubrr_payment_setting_approved_ecom'));


        $continueLink = get_site_url().'?wpsc_ajax_action=empty_cart';

        return $continueLink;
    }

    public function OnPaymentCanceled($shopOrderId, $sessionId)
    {
        $payment_module = new wpsc_merchant_ubrr($shopOrderId);
        $payment_module->set_purchase_processed_by_purchid(get_option('ubrr_payment_setting_canceled_ecom'));

        return false;
    }

    public function OnPaymentDeclined($shopOrderId, $sessionId)
    {
        $payment_module = new wpsc_merchant_ubrr($shopOrderId);
        $payment_module->set_purchase_processed_by_purchid(get_option('ubrr_payment_setting_declined_ecom'));

        return false;
    }
}


$Connector = new WordpressUBRiRConnector();
$eCommerceCallbackHandler = new eCommerceUBRIRCallback($Connector);
$eCommerceCallbackHandler->ProcessCallbackResponse();


if (!$eCommerceCallbackHandler->isRequestSuccessfullyParsed()) {
    die(); //Что-то странное
}

$eCommerceCallbackHandler->ShowCallbackProcessResult();

