<?php

include_once '../../WordpressPaymentMailNotification.php';
include_once '../../WordpressUBRiRConnector.php';
include_once '../../../wp-shop-original/classes/class.Wpshop.Order.php';
include_once 'wpshop_merchant.php';


class WPShopUBRIRCallback extends \UBRIR\CMS_PaymentCallback
{
    public function BeforeSendMailNotification(\UBRIR\PaymentResultViewer $resultData)
    {
        $orderId = $resultData->GetOrderId();
        $wpOrder = new Wpshop_Order($orderId);

        $email = $wpOrder->getOrderEmail();;

        $this->SetMailReceivers($email);

        return $resultData;
    }

    public function OnPaymentApproved($shopOrderId, $sessionId)
    {
        Wpshop_Orders::setStatus($shopOrderId, get_option('ubrr_payment_setting_approved_wpshop'));

//Очистка корзины
        global $wpdb;
        $param_remove = array(session_id());
        $res = $wpdb->get_results(
            $wpdb->prepare(
                "DELETE FROM {$wpdb->prefix}wpshop_selected_items WHERE selected_items_session_id='%s'",
                $param_remove
            )
        );

        $continueLink = get_site_url();

        return $continueLink;
    }

    public function OnPaymentCanceled($shopOrderId, $sessionId)
    {
        Wpshop_Orders::setStatus($shopOrderId, get_option('ubrr_payment_setting_canceled_wpshop'));

        return false;
    }

    public function OnPaymentDeclined($shopOrderId, $sessionId)
    {
        Wpshop_Orders::setStatus($shopOrderId, get_option('ubrr_payment_setting_declined_wpshop'));

        return false;
    }
}

$wordpressMailNotification = new WordpressPaymentMailNotification();

$Connector = new WordpressUBRiRConnector();
$WPShopCallbackHandler = new WPShopUBRIRCallback($Connector);
$WPShopCallbackHandler->ProcessCallbackResponse();
if (!$WPShopCallbackHandler->isRequestSuccessfullyParsed()) {
    die(); //Что-то странное
}

$WPShopCallbackHandler->ShowCallbackProcessResult();
